## eel -- eel.cm core client

This is the eel core client, which can be installed with npm and provides the `eel` command line utility.

[https://eel.cm](https://eel.cm) is a repository that stores encrypted blobs of environment variables. You can store
variable sets for your software in the repository, and fetch-decrypt-load them at runtime. This prevents your sensitive
environment variables like API access keys from ever having to sit in plain text files on your systems and developer
machines.

The repository functions similarly to modern password managers, and eel.cm does not have access to your environment
variables, they are decrypted locally after you fetch the blob. Don't lose your password!

### Prerequisites

You should have an account at [https://eel.cm](https://eel.cm) if you want to interact with the repository.

### Installing

Install the package with npm. This will provide a new command in your shell, called `eel`

```
npm install -g eel-js
```

### Usage

Just prefix any command you want to run with `eel`. Environment variables will be downloaded, decrypted, and your
command will be executed, now having access to them.

```bash
$ eel ./anything.sh -a 1 -b 2
Eel 2.3.0
Email: me@example.com
Password: *********
AuthSuccess
Choose the environment to load:
[1] myapp-dev
[2] myapp-prod
[3] otherapp-dev
Executing: ./anything.sh -a 1 -b 2 # process now has access to AWS_SECRET_ACCESS_KEY
```

```bash
$ eel java -jar mything.jar
```

```bash
$ eel gunicorn app:app
```

```bash
$ eel bin/rails server -e production -p 4000
```

### Access Tokens

Sometimes you need to execute things non-interactively. Create an access token for a specific environment at
[https://eel.cm](https://eel.cm) and use that instead of username/password. This is less secure than interactive authentication, but the server/container state, IP address, and other system data are used to detect
suspicious circumstances and deny access and/or notify you appropriately.

```bash
$ eel -t env_access_token ./start-my-software.sh -myoption myvalue
```

## License

This project is licensed under the GNU General Public License v3.0


